<!--********************************************************************************
 * Copyright (c) 2015, 2023 Contributors to the Eclipse Foundation
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 ********************************************************************************-->

<div class="mx-2">
  <mdm-channelgroup-selection-panel
    id="channelgroup-panel"
    [measurements]="measurements"
    (selectedMeasurementsChange)="onSelectedMeasurementsChange($event)"
    (selectedChannelGroupsChange)="onSelectedChannelGroupsChanged($event)"
  ></mdm-channelgroup-selection-panel>

  <p-panel [(collapsed)]="yChannelPanelCollapsed" toggler="header" class="list-box" [toggleable]="true" styleClass="my-2">
    <p-header class="title-bar channelgroups">
      <span class="icon channel"></span>&nbsp;Y-{{ "MeaQuantity" | mdmdatasourcetranslate }}
    </p-header>
    <ng-template pTemplate="icons">
      <p-overlayPanel #cogpanel>
        <ng-template pTemplate>
          <div class="field">
            <label for="userUnitPrefButton" [title]="'user-prefs.unit-prefs.lbl-unit-list' | translate">{{
              "user-prefs.unit-prefs.lbl-unit-list" | translate
            }}</label>
            <p-dropdown
              id="userUnitPrefButton"
              styleClass="w-full"
              [options]="groupedUserUnitPrefs"
              [group]="true"
              [(ngModel)]="selectedUnitPreference"
              [title]="'user-prefs.unit-prefs.lbl-unit-list' | translate"
              (onChange)="onChangedSelectedUnitPreference($event)"
            ></p-dropdown>
          </div>
          <div class="field">
            <label for="userChannelFilterPrefButton" [title]="'user-prefs.channel-filter-prefs.lbl-channel-filter-list' | translate">{{
              "user-prefs.channel-filter-prefs.lbl-channel-filter-list" | translate
            }}</label>
            <p-dropdown
              id="userChannelFilterPrefButton"
              styleClass="w-full"
              [options]="groupedUserChannelFilterPrefs"
              [group]="true"
              [(ngModel)]="selectedChannelFilterPreference"
              [title]="'user-prefs.channel-filter-prefs.lbl-channel-filter-list' | translate"
              (onChange)="onChangedSelectedChannelFilterPreference($event)"
            ></p-dropdown>
          </div>
        </ng-template>
      </p-overlayPanel>
      <p-button icon="pi pi-cog" styleClass="p-panel-header-icon p-link" (onClick)="cogpanel.toggle($event)"></p-button>
    </ng-template>
    <div class="channeltable">
      <p-table
        #yChannelTable
        [columns]="selectedView.columns"
        [value]="yChannelOptions"
        (onRowSelect)="onYChannelClick($event)"
        (onRowUnselect)="onYChannelClick($event)"
        (onHeaderCheckboxToggle)="onSelectAllYChannels($event)"
        [(selection)]="selectedTableChannels"
        dataKey="id"
        [scrollable]="true"
        scrollHeight="200px"
        scrollDirection="both"
        [resizableColumns]="true"
        columnResizeMode="expand"
        [paginator]="yChannelOptions?.length > maxYChannelRows"
        [rows]="maxYChannelRows"
        (sortFunction)="onSort($event)"
        [customSort]="true"
        styleClass="table-hover p-datatable-gridlines"
        tableStyleClass="w-min"
      >
        <ng-template pTemplate="caption">
          <div class="flex line-height-1">
            <div class="flex-none flex align-items-center justify-content-center m-1">
              <p-button
                icon="pi pi-pencil"
                (onClick)="editSelectedView($event)"
                [title]="'tableview.view.tooltip-edit-view' | translate"
              ></p-button>
            </div>
            <div class="flex-grow-1 flex align-items-center justify-content-center m-1">
              <p-columnFilter
                type="text"
                field="name"
                [pTooltip]="'chartviewer.xy-chart-data-selection-panel.tooltip-regexp-filter' | translate"
                [placeholder]="'chartviewer.xy-chart-data-selection-panel.filter' | translate"
                [matchModeOptions]="matchModeOptions"
                [matchMode]="isCaseSensitive ? 'regex_s' : 'regex_i'"
                [showClearButton]="false"
              ></p-columnFilter>
            </div>
          </div>
        </ng-template>
        <ng-template pTemplate="header" let-columns>
          <tr>
            <th style="max-width: 3em">
              <p-tableHeaderCheckbox></p-tableHeaderCheckbox>
            </th>
            <th pResizableColumn *ngFor="let col of columns" [pSortableColumn]="col" style="width: 15rem">
              <ng-container *ngIf="isUnitColumn(col); else elseDefaultHeader">
                {{ "chartviewer.xy-chart-data-selection-panel.display-unit" | translate }}
              </ng-container>
              <ng-template #elseDefaultHeader>{{ col.name }} ({{ col.type }})</ng-template>
              <p-sortIcon [field]="col"></p-sortIcon>
            </th>
          </tr>
        </ng-template>
        <ng-template pTemplate="body" let-row let-columns="columns">
          <tr>
            <td style="max-width: 3em">
              <p-tableCheckbox [value]="row"></p-tableCheckbox>
            </td>
            <ng-container *ngFor="let col of columns; let colIndex = index">
              <td *ngIf="isUnitColumn(col); else elseDefaultValue" style="width: 15rem; padding: 0">
                <p-dropdown
                  [style]="{ width: '100%', 'min-width': '100%' }"
                  class="unit-dropdown"
                  [(ngModel)]="row.selectedUnitId"
                  [options]="row.unitList"
                  optionLabel="unitName"
                  optionValue="unitId"
                  (onChange)="onUnitChange(row.id)"
                  appendTo="body"
                ></p-dropdown>
              </td>
              <ng-template #elseDefaultValue
                ><td style="width: 15rem">{{ row?.columns?.length > colIndex ? row?.columns[colIndex] : "---" }}</td></ng-template
              >
            </ng-container>
          </tr>
        </ng-template>
        <ng-template pTemplate="emptymessage" let-columns>
          <tr>
            <td [attr.colspan]="columns.length" style="text-align: center">No data</td>
          </tr>
        </ng-template>
      </p-table>
    </div>
  </p-panel>
  <mdm-edit-view></mdm-edit-view>

  <p-panel [(collapsed)]="xChannelPanelCollapsed" toggler="header" [toggleable]="true">
    <p-header class="title-bar channelgroups">
      <span class="icon channel"></span> &nbsp;X-{{ "MeaQuantity" | mdmdatasourcetranslate }}
    </p-header>
    <p-table [value]="selectedChannelRows" styleClass="table-hover p-datatable-gridlines">
      <ng-template pTemplate="body" let-row>
        <tr>
          <td style="vertical-align: middle" [title]="row.yChannel.name">{{ row.yChannel.name }}</td>
          <td style="line-height: 1">
            <p-dropdown
              [(ngModel)]="row.xChannel"
              [options]="xChannelOptions[row.channelGroup.id]"
              appendTo="body"
              [filter]="xChannelOptions[row.channelGroup.id]?.length > 5"
              (onChange)="onSelectedXChannelChanged($event, row)"
              (onShow)="onShowSelectedXChannelChanged(row)"
              [placeholder]="'chartviewer.xy-chart-data-selection-panel.select-channel-placeholder' | translate"
              optionLabel="name"
              [showClear]="false"
              [style]="{ width: '100%' }"
            >
            </p-dropdown>
          </td>
          <td>
            <p-button
              (click)="useChannelForAll(row)"
              [label]="'chartviewer.xy-chart-data-selection-panel.select-channel-for-all' | translate"
            ></p-button>
          </td>
        </tr>
      </ng-template>
    </p-table>
  </p-panel>

  <p-confirmDialog icon="pi pi-exclamation-triangle"></p-confirmDialog>

  <p-dialog [(visible)]="isYChannelQueryConfigDialogVisible" [style]="{ width: '50rem' }">
    <p-header>
      {{ "chartviewer.xy-chart-data-selection-panel.y-channel-query-config-editor" | translate }}
    </p-header>
    <div class="p-grid">
      <div class="p-col-4">
        {{ "chartviewer.xy-chart-data-selection-panel.result-offset" | translate }}
      </div>
      <div class="p-col-8">
        <input
          pInputText
          [(ngModel)]="dialogResultOffset"
          style="width: 100%"
          [placeholder]="'chartviewer.xy-chart-data-selection-panel.result-offset' | translate"
        />
      </div>
      <div class="p-col-4">
        {{ "chartviewer.xy-chart-data-selection-panel.result-limit" | translate }}
      </div>
      <div class="p-col-4">
        <p-selectButton [options]="resultLimitModeOptions" [(ngModel)]="dialogResultLimitMode" [style]="{ width: '100%' }">
          <ng-template let-item>
            <span>{{ item.label | translate }}</span>
          </ng-template>
        </p-selectButton>
      </div>
      <div class="p-col-4">
        <input
          pInputText
          [(ngModel)]="dialogResultLimit"
          style="width: 100%"
          [disabled]="dialogResultLimitMode !== 'MANUAL'"
          [placeholder]="'chartviewer.xy-chart-data-selection-panel.result-limit-manual-input' | translate"
        />
      </div>
    </div>
    <p-footer>
      <div class="p-grid">
        <div class="p-offset-8 p-col-2">
          <button
            pButton
            class="btn-mdm"
            (click)="onApplyYChannelQueryConfig()"
            style="width: 100%"
            icon="pi pi-check"
            [label]="'chartviewer.xy-chart-data-selection-panel.apply' | translate"
          ></button>
        </div>
        <div class="p-col-2">
          <button
            pButton
            class="btn-mdm"
            (click)="onCloseYChannelConfigDialog()"
            style="width: 100%"
            icon="pi pi-times"
            [label]="'chartviewer.xy-chart-data-selection-panel.cancel' | translate"
          ></button>
        </div>
      </div>
    </p-footer>
  </p-dialog>
</div>
